--[==========================================[
  =         Temporary Ball Container         =
--]==========================================]


require 'util.color'
require 'ball'

local Balls = {}

Balls.newRandomBall = function (self)
	local radius = RandomGenerator:random(TUNING.BALLS.MIN_RADIUS,TUNING.BALLS.MAX_RADIUS)
	local x = RandomGenerator:random(radius,Client.width-radius)
	local x_vel = RandomGenerator:random(-TUNING.BALLS.MAX_SPAWN_VELOCITY,TUNING.BALLS.MAX_SPAWN_VELOCITY)/10
	local y = RandomGenerator:random(radius,Client.height-radius)
	local y_vel = RandomGenerator:random(-TUNING.BALLS.MAX_SPAWN_VELOCITY,TUNING.BALLS.MAX_SPAWN_VELOCITY)/10
	local color = Color(
		math.round(RandomGenerator:random(255)),
		math.round(RandomGenerator:random(255)),
		math.round(RandomGenerator:random(255))
	)
	local ball = Ball(radius, Vector2(x, y), Vector2(x_vel, y_vel), color)
	table.insert(Balls, ball)
end

Balls.addBalls = function (self, count)
	for i=1,count do
		self:newRandomBall()
	end
end

Balls.draw = function (self)
	for i,Ball in ipairs(self) do
		love.graphics.setColor(Ball.color._r, Ball.color._g, Ball.color._b, 200)
		love.graphics.circle( "fill", Ball.position.x, Ball.position.y, Ball.radius, 36)
	end
end

Balls.clear = function (self)
	for i,Ball in ipairs(self) do
		self[i] = nil
	end
end

Balls.reset = function (self)
	--- clear any previous balls
	self:clear()
	self:addBalls(TUNING.BALLS.MAX_COUNT)
end

return Balls
