--[========================================[
  =         Math Utility Functions         =
--]========================================]


--- clamp a given number between a max and a min
function math.clamp (num, min, max)
	num = math.max(min, num)
	num = math.min(max, num)
	return num
end

---- Round number to the provided decimal places
function math.round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

--- Linear interpolation function
function lerp (a, b, t)
	return a + (b - a) * t
end

--- XOR operator
function op_xor (a, b)
	return ((a or b) and (not (a and b)))
end


